<?php

class LogData {
	
	//---------------------------------------------------------
	//  コントロール設定
	//---------------------------------------------------------
	
	public static function control() {
		
		// コントロール設定を返す
		return array(true, true, 'Header', 'Footer');
		
	}
	
	//---------------------------------------------------------
	//  管理メニュー表示
	//---------------------------------------------------------
	
	public static function execute() {
		
		// DBクラスを取得
		$db = $GLOBALS['obj']['db'];
		
		// テンプレートクラスを取得
		$tmpl = $GLOBALS['obj']['tmpl'];
		/*
		// DBが存在しない時は終了
		if (!$db->exists(MAIN_DB)) {
			return;
		}
		*/
		// URLルートを設定
		$vars['root'] = ROOT;
		
		// 変数を初期化
		$vars['convert'] = '';
		
		// データフォルダのファイル名を取得
		$files = glob(DATA_DIR . '/access*.db');
		
		////////////////////////////////////////////////////////////
		
		// ヘッダー,メイン,フッター テンプレートを取得
		list($totalForm, $etcLink, $head, $body, $foot) = $tmpl->read('log_data.htm');
		
		// リクエストメソッドがPOSTの時
		if ($_SERVER['REQUEST_METHOD'] === 'POST') {
			
			// 実行メソッド名を取得
			$method = $GLOBALS['args'][1];
			
			// 変更/削除処理実行
			$vars['convert'] = self::$method($db, $files);
			
		}
		
		////////////////////////////////////////////////////////////
		
		// フラグを初期化
		$exists = false;
		
		// テーブル名を取得
		$totalTable = $db->table('total');
		
		// クエリーを作成
		$query = "select * from $totalTable;";
		
		// クエリーを実行
		$rec = $db->queryFetch($query);
		
		// カウントデータが存在する時
		if ($rec) {
			
			// 累計アクセス数を取得
			$vars['totalUU'] = $rec['total_uu'];
			$vars['totalPV'] = $rec['total_pv'];
			
			// フラグをtrueに設定
			$exists = true;
			
		}
		
		// カウントデータが存在しない時
		else {
			
			// 累計アクセス数を取得
			$vars['totalUU'] = 0;
			$vars['totalPV'] = 0;
			
		}
		
		////////////////////////////////////////////////////////////
		
		// 累計カウント修正テンプレートを出力
		$tmpl->show($totalForm, $vars);
		
		// その他テーブルを出力
		if ($exists) {
			$tmpl->show($etcLink, $vars);
		}
		
		// 月間テーブルリストを出力
		self::showMonthlyTable($tmpl, $files, $head, $body, $foot);
		
	}
	
	//---------------------------------------------------------
	//  テーブル名表示
	//---------------------------------------------------------
	
	private static function showMonthlyTable($tmpl, $files, $head, $body, $foot) {
		
		// ファイル名配列を降順ソート
		rsort($files);
		
		// テーブル名を配列で設定
		$tables = array('count', 'param', 'daily', 'visit');
		
		// URLルートを設定
		$vars['root'] = ROOT;
		
		// ファイル名を取得するループ
		foreach ($files as $file) {
			
			// 検索DB名を設定
			$reg = '(access_)(\d{4}_\d{2})\.db';
			
			// テーブル名配列に入れる
			if (!preg_match("/$reg/", $file, $m)) {
				continue;
			}
			
			// ヘッダーテンプレートを出力
			$tmpl->show($head);
			
			// テーブル名出力ループ
			foreach ($tables as $table) {
				
				// テーブル名を設定
				$vars['table'] = $m[2] . '_' . $table;
				
				// メインテンプレートを出力
				$tmpl->show($body, $vars);
				
			}
			
			// フッターテンプレートを出力
			$tmpl->show($foot);
			
		}
		
	}
	
	//---------------------------------------------------------
	//  累計アクセス数の変更
	//---------------------------------------------------------
	
	private static function rewrite($db) {
		
		// テーブル名を取得
		$totalTable = $db->table('total');
		
		// アクセス数を取得（数値以外の文字列を削除）
		$totalUU = ($GLOBALS['args']['total_uu']) ? preg_replace('/[^0-9]/', '', $GLOBALS['args']['total_uu']) : 0;
		$totalPV = ($GLOBALS['args']['total_pv']) ? preg_replace('/[^0-9]/', '', $GLOBALS['args']['total_pv']) : 0;
		
		// 空欄補正（ユニーク）
		if (!$totalUU) {
			$totalUU = 0;
		}
		
		// 空欄補正（PV）
		if (!$totalPV) {
			$totalPV = 0;
		}
		
		// クエリーを作成
		$query = "update $totalTable set total_uu = $totalUU, total_pv = $totalPV;";
		
		// クエリーを実行
		$db->query($query);
		
	}
	
	//---------------------------------------------------------
	//  ログコンバート
	//---------------------------------------------------------
	
	public static function convert($db, $files) {
		
		// クラスを読み込み
		include(WORK_DIR . '/modules/Sql.php');
		/*
		// DBが存在しない時
		if (!$db->exists(MAIN_DB)) {
			
			// テーブルを生成
			$db->query(Sql::createTotalTable($db->table('total')));
			$db->query(Sql::createPageTable($db->table('page')));
			$db->query(Sql::createPageTable($db->table('click')));
			$db->query(Sql::createPageTable($db->table('referrer')));
			
			// 旧テーブルの内容をコピー
			
		}
		*/
		////////////////////////////////////////////////////////////
		
		// ファイル名配列を降順ソート
		rsort($files);
		
		// テーブル名を配列で設定
		$tables = array('count', 'param', 'daily', 'visit');
		
		// 結果表示文字列を設定
		$convert = '';
		
		// タブを設定
		$tab = "\n\t\t\t\t\t";
		
		////////////////////////////////////////////////////////////
		
		// DB名を取得するループ
		foreach ($files as $file) {
			
			// メインDBの時は次へ
			if (preg_match('/_master|_main/', $file)) {
				continue;
			}
			
			// ファイル名を切り出す
			$atDB = basename($file);
			
			// DBに接続
			$db->attach($atDB);
			
			//////////////////////////////////////////////////////////////////////
			/*
			// テーブルを生成
			$db->query(Sql::createCountTable($countTable));
			$db->query(Sql::createVisitTable($visitTable));
			$db->query(Sql::createParamTable($paramTable));
			$db->query(Sql::createDailyTable($dailyTable));
			
			// 旧テーブルの内容をコピー
			
			*/
			//////////////////////////////////////////////////////////////////////
			
			// DBから切断
			$db->detach();
			
			// メッセージを追記
			$convert .=  $tab . '<p class="convert">' . $atDB . ' を変換しました！</p>';
			
		}
		
		////////////////////////////////////////////////////////////
		
		// メッセージを追記
		if (!$convert) {
			$convert = $tab . '<p class="convert">変換は必要ありませんでした！</p>';
		}
		
		// メッセージを返す
		return $convert;
		
	}
	
}

