<?php

class SP {
	
	//---------------------------------------------------------
	//  コントロール設定
	//---------------------------------------------------------
	
	public static function control() {
		
		// コントロール設定を返す
		return array(false, true, false, 'Footer');
		
	}
	
	//---------------------------------------------------------
	//  メイン処理
	//---------------------------------------------------------
	
	public static function execute() {
		
		// テンプレートクラスを取得
		$tmpl = $GLOBALS['obj']['tmpl'];
		
		// テンプレートディレクトリを再設定
		$tmpl->setDir(WORK_DIR . '/templates/htm/sp');
		
		// 折れ線グラフ設定をoffに変更
		$GLOBALS['conf']['allowLineChart'] = 0;
		
		// 変数を初期化
		$newArgs = array();
		
		// アクション名（sp）を削除
		unset($GLOBALS['args']['act']);
		unset($GLOBALS['args'][0]);
		
		// アクション名を取得
		$act = (isset($GLOBALS['args'][1])) ? $GLOBALS['args'][1] : 'index';
		
		// リクエストメソッドを取得
		$method = $_SERVER['REQUEST_METHOD'];
		
		// GETメソッドの時
		if ($method === 'GET') {
			
			// データ取得ループ
			foreach ($GLOBALS['args'] as $key => $val) {
				
				// キーをデクリメント
				$i = --$key;
				
				// 値を新しい配列に設定
				$newArgs[$i] = $val;
				
			}
			
			// 配列を入れ直し
			$GLOBALS['args'] = $newArgs;
			
		}
		
		// クラス名に変換
		$class = Controller::toUpperCamel($act);
		
		// アクション名を再設定
		$GLOBALS['args']['act'] = $act;
		
		// クラス名を再設定
		$GLOBALS['args']['class'] = $class;
		
		////////////////////////////////////////////////////////////
		
		// ログイン認証クラスを読み込み
		include(FW_DIR . '/modules/core/Login.php');
		
		// ヘッダークラスを読み込み
		include(WORK_DIR . '/filters/Header.php');
		
		// メインクラスを読み込み
		include(WORK_DIR . '/actions/' . $class . '.php');
		
		// ログイン処理実行
		Login::execute();
		
		// ヘッダー処理実行
		Header::execute();
		
		// メイン処理実行
		call_user_func($class . '::execute');
		
	}
	
}

