
// ポップアップ表示View
var popView;

// addEventListenerが使用可能な時
if (window.addEventListener) {
	
	// ページ読み込み完了後にイベントを設定
	window.addEventListener('load', setEvent, false);
	
	// 端末の向きが変化した時のイベントを設定
	window.addEventListener('orientationchange', hideAdBar, false);
	
}

//////////////////////////////////////////////////////////////

// リンクイベントを設定
function setEvent() {
	
	// リンクの数を取得
	var lentgh = document.links.length;
	
	// リンクの数だけループ
	for (i = 0; i < lentgh; i++) {
		
		// 要素を取得
		var node = document.links[i];
		
		// クラス名を取得
		var className = link.className;
		
		// 内部リンクの時
		if (className == 'in') {
			
			// 次へ
			continue;
			
		}
		
		// 外部リンクの時
		else if (className == 'out') {
			
			// ターゲット属性を設定
			node.target = '_blank';
			
			// URLに追記
			node.href += '::sp';
			
			// 次へ
			continue;
			
		}
		
		// ポップアップの時
		else if (className == 'pop') {
			
			// タッチイベントを設定
			node.addEventListener('touchstart', showPopView, false);
			node.addEventListener('touchend', hidePopView,false);
			
			// リンクとしては動作させない
			node.addEventListener('click', noAction, false);
			
		}
		
		// それ以外のリンクの時
		else {
			
			// URLを取得
			var url = node.href;
			
			// URLをスマホ向けに変換
			url = url.replace(/index.php\//, "");
			url = url.replace(/analyzer/, "analyzer/index.php/sp");
			
			// URLを再設定
			node.href = url;
			
		}
		
	}
	
	// Viewを取得
	popView = document.getElementById('pop');
	
	// タッチイベントを設定
	popView.addEventListener('touchstart', hidePopView, false);
	
	// アドレスバーを非表示にする
	hideAdBar();
	
}

//////////////////////////////////////////////////////////////

// アドレスバーを非表示にする
function hideAdBar() {
	
	// 時間差で1pxスクロール
	setTimeout("scrollTo(0, 1)", 100);
	
}

//////////////////////////////////////////////////////////////

// 何もしない
function noAction(e) {
	
	// 親要素のイベントは実行しない
	e.stopPropagation();
	
	// 終了
	e.preventDefault();
	
}

//////////////////////////////////////////////////////////////

// ポップViewを表示
function showPopView(e) {
	
	// URLを取得
	var url = this.href;
	
	// URL引数のみを切り出し
	var argsStr = url.replace(/^\S+\/route\//, "");
	
	// 引数を「/」で分割
	var args = argsStr.split('/');
	
	// ページ配列
	var pages = args[0].split('-');
	
	// 滞在時間配列
	var times = args[1].split('-');
	
	// クリック配列
	var clicks = args[2].split('-');
	
	// 表示するHTML
	var html = '';
	
	// 配列数分ループ
	for (i in pages) {
		
		// IDを取得
		var pageId = 'page' + pages[i];
		
		// タイトルをHTMLに追記
		if (titles[pageId]) {
			html += titles[pageId];
		} else {
			html += 'Undefined';
		}
		
		// 時間が存在する時
		if (times[i]) {
			html += ' &nbsp;' + times[i];
		}
		
		// 改行を追記
		html += '<br>';
		
	}
	
	// クリック配列が存在する時
	if (args[2]) {
		
		// 区切り線を追記
		html += '<hr>';
		
		// 配列数分ループ
		for (j in clicks) {
			
			// IDを取得
			var clickId = 'click' + clicks[j];
			
			// タイトルをHTMLに追記
			if (titles[clickId]) {
				html += titles[clickId];
			} else {
				html += 'Undefined';
			}
			
			// 改行を追記
			html += '<br>';
			
		}
		
	}
	
	// イベントが発生した座標を取得
	var top = (e) ? e.pageY : event.touches[0].pageY;
	
	// ViewのHTMLを設定
	popView.innerHTML = html;
	
	// Viewの位置を設定
	popView.style.top = top + 20 + 'px';
	
	// Viewを表示
	popView.style.visibility = 'visible';
	
}

//////////////////////////////////////////////////////////////

// ポップViewを非表示
function hidePopView() {
	
	// Viewを非表示
	popView.style.visibility = 'hidden';
	
	// ViewのHTMLをリセット
	popView.innerHTML = '';
	
}

//////////////////////////////////////////////////////////////

// Formの送信ボタンを無効に設定（二重送信防止）
function submitDisabled(i) {
	
	// ボタンを無効に設定
	document.forms[i].submit.disabled = true;
	
}

